<?php

use CB\Database\Table\UserTable;

if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

global $_PLUGINS;
$_PLUGINS->registerFunction( 'onCPayAfterPaymentStatusUpdateEvent', 'onCPayAfterPaymentStatusUpdateEvent', 'getahainvoicemanagerTab' );

class getahainvoicemanagerTab extends cbTabHandler {
	
	protected function getFieldValue( $user, $fieldId ) {
		if ( $fieldId ) {
			$cbUser	=	CBuser::getInstance( (int) $user->id, false );
			$value	=	$cbUser->getField( (int) $fieldId, null, 'csv' );
			$format	=	htmlspecialchars( urlencode( trim( $value ) ) );
		} else {
			$format	=	null;
		}

		return $format;
	}
	
 	public function onCPayAfterPaymentStatusUpdateEvent( $user, $paymentBasket, /** @noinspection PhpUnusedParameterInspection */ $subscriptions, $unifiedStatus, /** @noinspection PhpUnusedParameterInspection */ $previousUnifiedStatus, /** @noinspection PhpUnusedParameterInspection */ $eventType, /** @noinspection PhpUnusedParameterInspection */ $notification ) {
		global $_CB_framework;


		$params							=	cbpaidApp::settingsParams();
		$invFile						=	$_CB_framework->getCfg( 'absolute_path' ) . '/components/com_invoices/helpers/helpers.php';
		if ( ! file_exists( $invFile ) ) {
			return;
		}
		$paramsiv = JComponentHelper::getParams( 'com_invoices' );
		$component = "com_comprofiler" ;
		include_once($invFile);

		$db = JFactory::getDBO();

		$is_new = false;
		$newpay = false;
		$must_update = false ;
		$reversal = "";
		$invoice_id = 0 ;
		//we check if this particular order-payment combination exists for CBsubs 
		$query = "SELECT * FROM #__cbsubs_payments WHERE payment_basket_id = '".$paymentBasket->id."' ORDER BY time_paid DESC LIMIT 1";
		$db->setQuery($query);
		$last_payment = $db->loadObject();
				
		// we check it is a refund to output a new invoice/credit note 
		if($previousUnifiedStatus == "Completed" && ($paymentBasket->payment_status == "Partially-Refunded" || $paymentBasket->payment_status == "Refunded")) {
			//$query = "SELECT * FROM #__cbsubs_payments WHERE payment_basket_id = '".$paymentBasket->id."' ORDER BY time_paid DESC LIMIT 1 OFFSET 1";
			$query = "SELECT * FROM #__cbsubs_payments WHERE payment_basket_id = '".$paymentBasket->id."' ORDER BY time_paid DESC LIMIT 1";			
			$db->setQuery($query);
			$last_payment = $db->loadObject();	
			$is_new = true;		
		}
			
		// we check it is a reversed to keep the invoice		
		if($paymentBasket->payment_status == "Reversed") {
			$query = "SELECT * FROM #__cbsubs_payments WHERE payment_basket_id = '".$paymentBasket->id."' ORDER BY time_paid DESC LIMIT 1 OFFSET 1";
			$db->setQuery($query);
			$last_payment = $db->loadObject();	
		}	
					
		if(!$last_payment){
			$newpay = true;
		}	
						
		//we check if this particular order had already been tracked
		$query = " SELECT id FROM #__invoices_invoices WHERE external_type = '".$component."' AND external_id = ". $paymentBasket->id . $last_payment->id;
		$db->setQuery($query);
		$exists = $db->loadResult();

		if(!$exists){
			$is_new = true ;
		}
		else{
			$must_update = true ;
			$invoice_id = $exists;
		}
		
		if($is_new || $must_update){

			$query = ' SELECT i.real_invoice_num FROM #__invoices_invoices as i WHERE i.type = 1 '.' ORDER BY i.id DESC ';
			$db->setQuery( $query );
			$real_invoice_num = $db->loadResult() + 1;
			$invoice_num = InvoicesHelper::getInvoiceNum($real_invoice_num) ;

			$taxes = array();

			$invoice_date = date('Y-m-d H:i:s');

			$app = JFactory::getApplication();
			if($app->isSite()) $language = "fr-FR"; 
			else $language = $paramsiv->get('default_language', 'en-GB');

			$link_contact = 2;
			$contact_id = 0;

			$query = " SELECT id FROM #__invoices_contacts WHERE email = '". $paymentBasket->payer_email ."'";
			$db->setQuery($query);
			$contact_id = (int)$db->loadResult();

			if($contact_id) $link_contact = 1;

			if(!$is_new){ // we are updating. These fields should NOT be updated.
				$real_invoice_num = null;
				$invoice_num = null;
				$invoice_date = null;
				$language = null;
				$link_contact = 1;
				$contact_id = null;
			}
			
			$invoice_status = null;
			$templateid = 1;
			if($last_payment->reason_code == "Refund" || $paymentBasket->payment_status == "Refunded" || $paymentBasket->payment_status == "Partially-Refunded") {
				$invoice_status = "refunded";
				$templateid = 3;
			}
			
			$invoice_data = array(
							"id" => $invoice_id ,
							"to_name" => $paymentBasket->first_name . " " .$paymentBasket->last_name,
							"to_company" => $paymentBasket->payer_business_name,
							"to_address" => $paymentBasket->address_street,
							"to_email" => $paymentBasket->payer_email,
							"to_zipcode" => $paymentBasket->address_zip,
							"to_city" => $paymentBasket->address_city,
							"to_state" => $paymentBasket->address_state,
							"to_country" => $paymentBasket->address_country,
							"to_phone" => $paymentBasket->contact_phone,
							"to_vatid" => $paymentBasket->vat_number,
							"vincular_cliente_checkbox" => $link_contact,
							"user_id" => $contact_id,
							"from_name" => $paramsiv->get('from_name'),
							"from_address" => $paramsiv->get('from_address'),
							"from_num" => $paramsiv->get('from_num'),
							"from_url" => $paramsiv->get('from_url'),
							"from_email" => $paramsiv->get('from_email'),
							"from_phone" => $paramsiv->get('from_phone'),
							"invoice_num" => $invoice_num,
							"real_invoice_num" => $real_invoice_num,
							"invoice_date" => $invoice_date,
							"template_id" => $paramsiv->get('invoice_template'),
							"currency_id" => $paramsiv->get('currency_id'),
							"language" => $language,
// 							"publish" => $paramsiv->get('activation'),
							"publish" => 1,
// 							"is_recurrent" => $paymentBasket->recurring,
							"start_publish" => null,
							"end_publish" => null,
							//to do invoice date plus 15j
							"invoice_duedate" => date('Y-m-d H:i:s', strtotime(' + 10 days')),
							"joomla_user_id" => $paymentBasket->user_id,
							"taxes" => $taxes,
							"status" => $invoice_status,
							"external_type" => $component,
							"external_id" => $paymentBasket->id. $last_payment->id,
							"external_ref" => $paymentBasket->invoice,
							"template_id"=> $templateid,
							//"discount" => $order_discount_price,
							"sendemail" => $paramsiv->get('sendemail', 0)
							) ;


		$items = array();

		if($newpay){
			$value = ($paymentBasket->mc_gross-$paymentBasket->tax);
			$diff = ($paymentBasket->mc_gross-$value);
			$tax = ($diff / $value ) * 100;
		} 
		else {
			$value = ($paymentBasket->mc_gross-$paymentBasket->tax);
			$diff = ($paymentBasket->mc_gross-$value);
			$tax = ($diff / $value ) * 100;
			$value = $last_payment->mc_gross/(1+($tax/100));
			//$value = ($last_payment->mc_gross-$last_payment->tax);
			$diff = ($last_payment->mc_gross-$value);		
		}
			
		//to do vérifier le calcul de la TVA sur CBsubs, pour le moment on mets 20% par défaut
		//if($paymentBasket->tax > 0) $thetax = round(( $diff / $value ) * 100, $paramsiv->get('roundtax', 2)) ;
		if($paymentBasket->tax > 0) $thetax = 20 ;

		else $thetax = 0;
		
// 		if( $paymentBasket->payment_status == "Reversed" ) {
// 			$value = $last_payment->payment_gross-$last_payment->tax;
// 			$diff = $last_payment->payment_gross-$value;	
// 			$thetax = round(( $diff / $value ) * 100, $paramsiv->get('roundtax', 2));
// 			$value = $last_payment->mc_gross/(1+($thetax/100));	
// 		}
		
		if(($paymentBasket->payment_status == "Refunded" || $paymentBasket->payment_status == "Partially-Refunded") && $previousUnifiedStatus == "Completed" ) {
			$value = $last_payment->payment_gross-$last_payment->tax;
			$diff = $last_payment->payment_gross-$value;	
			$thetax = round(( $diff / $value ) * 100, $paramsiv->get('roundtax', 2));
			$value = $last_payment->mc_gross/(1+($thetax/100));	
		}		
		
		$products = $paymentBasket->loadPaymentItems();
		
		foreach($products as $product){ 
				$name = $product->alias;
				$sku = $product->plan_id;
				$subscription =	$product->loadSubscription();
				$plan =	$subscription ? $subscription->getPlan() : cbpaidPlansMgr::getInstance()->loadPlan( $product->plan_id );
				if ( !$plan ) {
					$plan_name =  "Prestations";
				}
				//$plan_name = CBPTXT::T( $plan->name );
				$plan_name = CBPTXT::T( $plan->alias );
							
// 		 		print_r($subscription);
// 		 		die;
		$items[] = array(
							"id" => $paymentBasket->id,
							"sku" => $sku,
							"name" => $plan_name,
							"desc" => $paymentBasket->item_number,
							"value" => $value,
							"amount" => $paymentBasket->quantity,
							"tax" => $thetax  ,
							"tax_id" => $paramsiv->get('tax_id', 0),
							"external_type" => $component,
							"product_id" => $products->artnum,
							);
		}
		
		//Shipping
		if($paymentBasket->mc_shipping > 0){

			$shipping_name = "";
			$shipping_name = $paymentBasket->shipping;

			$shipping_price = $paymentBasket->mc_shipping;

			$shipping_item_exists = 0;

			if($must_update){
				$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."_shipping' ";
				$db->setQuery($query);
				$shipping_item_exists = $db->loadResult();
			}

			$shipping_item_id = $shipping_item_exists ;

			$items[] = array(
								"id" => $shipping_item_id,
								"sku" => "",
								"name" => JText::_("Shipping"),
								"desc" => $shipping_name,
								"value" => $shipping_price,
								"amount" => 1,
								"tax" => ( $theorder->tax / $shipping_price ) * 100,
								"tax_id" => $paramsiv->get('tax_id', 0),
								"external_type" => $component."_shipping",
								"product_id" => 0,
								);
		}

		//Payment
			if($paymentBasket->mc_gross > 0){

				$payment_name = "";
				$payment_name = $paymentBasket->payment_type;

				$payment_item_exists = 0 ;

				if($must_update){
					$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."_payment'";
					$db->setQuery($query);
					$payment_item_exists = $db->loadResult();
				}

				$payment_item_id = $payment_item_exists ;

				$items[] = array(
									"id" => $payment_item_id,
									"sku" => $sku,
									"name" => $plan_name,
									"desc" => $paymentBasket->item_number,
									"value" => $value,
									"amount" => $paymentBasket->quantity,
									"tax" => $thetax ,
									"tax_id" => $paramsiv->get('tax_id', 0),
									"external_type" => $component."_payment",
									"product_id" => $products->artnum

									);
			}
		
			$payments = array();

		//add to affiliate tracker		
			if ($paymentBasket->payment_status == "Completed") {
				$payment_status = 1 ;
							
				$db = JFactory::getDBO();

				//we check if this particular order had already been tracked in Affiliate Tracker
				$query = " SELECT id FROM #__affiliate_tracker_conversions WHERE component = 'com_comprofiler' AND type = ".$paymentBasket->user_id." AND reference_id = ".$paymentBasket->id . $last_payment->id;
				$db->setQuery($query);
				$exists = $db->loadResult();

				//if it didn't exist, we attemp to create the conversion
				if(!$exists){
					//check parent
					$query = " SELECT parent_id FROM #__affiliate_tracker_accounts WHERE user_id = ".$paymentBasket->user_id;
					$db->setQuery($query);
					$atid = $db->loadResult();
					if(!$atid) {
					$atid = null;
					//$atid = get_atid_from_cookie();
					// todo : on remplace le champs cb_codeparrainpartenaire par cb_codeatid, champs à insérer dans CB
				// 	$basketatid = $basketUser->get( 'cb_codeatid' );
// 					if ( $basketatid > 0 ) {
// 						$atid	=	$basketUser->get( 'cb_codeatid' );
// 						} 
// 					elseif ( ! \CBLib\Application\Application::MyUser()->isGlobalModerator() ) {
// 						//to do vérifier que atid ok du cookie 
// 						//$atid	=	stripslashes( cbGetParam( $_COOKIE, 'atid', null ) );
// 						$atid = get_atid_from_cookie();
// 						}
					}
					$convname = ( $paymentBasket->user_id. " ".$paymentBasket->payer_business_name . "<br />" . $plan_name . "<br />" . $paymentBasket->item_number . " - Ref paiement: " . $last_payment->id  );
					
					$convextname = ( $plan_name . "<br /> Ref paiement: " . $last_payment->id );
					//to allow affiliates to sort items according to CB user id
					$type = $paymentBasket->user_id;
					
					$conversion_data = array(
					"name" => $convname,
					"component" => "com_comprofiler",
					"extended_name" => $convextname,
					"type" => $type,
					"value" => (float)$value,
					"reference_id" => ( $paymentBasket->id . $last_payment->id ),
					"approved" => 1,
					"atid" => $atid
		);
				$atFile						=	$_CB_framework->getCfg( 'absolute_path' ) . '/components/com_affiliatetracker/helpers/helpers.php';

				if ( ! file_exists( $atFile ) ) {
					return;
				}

			/** @noinspection PhpIncludeInspection */
				include_once( $atFile );
				AffiliateHelper::create_conversion($conversion_data, $paymentBasket->user_id);
					}
			}
						
			if ($paymentBasket->payment_status == "Reversed" && $previousUnifiedStatus == "Completed") {
				$payment_status = 0 ;
				$db = JFactory::getDBO();

				//we check if this particular order had already been tracked in Affiliate Tracker
				$query = " SELECT id FROM #__affiliate_tracker_conversions WHERE component = 'com_comprofiler' AND type = ".$paymentBasket->user_id." AND reference_id = ".$paymentBasket->id . $last_payment->id;
				$db->setQuery($query);
				$exists = $db->loadResult();

				//if it didn't exist, we do not reverse the conversion
				if($exists){
					//check parent
					$query = " SELECT parent_id FROM #__affiliate_tracker_accounts WHERE user_id = ".$paymentBasket->user_id;
					$db->setQuery($query);
					$atid = $db->loadResult();
					if(!$atid) {
					$atid = null;
					}
					$convname = ( $paymentBasket->user_id. " ".$paymentBasket->payer_business_name . "<br />" . $plan_name . "<br />" . $paymentBasket->item_number . " - <span class='text-danger'> Impayé client ref : " . $last_payment->id ."</span>" );
					$convextname = ( $plan_name . "<br /> <span class='text-danger'> Impayé client ref : " . $last_payment->id ."</span>");
					//to allow affiliates to sort items according to CB user id
					$type = $paymentBasket->user_id;
				
					$conversion_data_r = array(
					"name" => $convname,
					"component" => "com_comprofiler",
					"extended_name" => $convextname,
					"type" => $type,
					"value" => (float)$value * (-1),
					"reference_id" => ( $paymentBasket->id . $last_payment->id ),
					"approved" => 1,
					"atid" => $atid
		);
				$atFile						=	$_CB_framework->getCfg( 'absolute_path' ) . '/components/com_affiliatetracker/helpers/helpers.php';

				if ( ! file_exists( $atFile ) ) {
					return;
				}

			/** @noinspection PhpIncludeInspection */
				include_once( $atFile );
				AffiliateHelper::create_conversion($conversion_data_r, $paymentBasket->user_id);
					}
			
			}
			
			if (($paymentBasket->payment_status == "Refunded" || $paymentBasket->payment_status == "Partially-Refunded") && $previousUnifiedStatus == "Completed") {
				$payment_status = 1 ;
				$db = JFactory::getDBO();

				//we check if this particular order had already been tracked in Affiliate Tracker
				$query = " SELECT id FROM #__affiliate_tracker_conversions WHERE component = 'com_comprofiler' AND type = ".$paymentBasket->user_id." AND reference_id = ".$paymentBasket->id . $last_payment->id;
				$db->setQuery($query);
				$exists = $db->loadResult();

				if(!$exists){
					//check parent
					$query = " SELECT parent_id FROM #__affiliate_tracker_accounts WHERE user_id = ".$paymentBasket->user_id;
					$db->setQuery($query);
					$atid = $db->loadResult();
					if(!$atid) {
					$atid = null;
					}
					$convname = ( $paymentBasket->user_id. " ".$paymentBasket->payer_business_name . "<br />" . $plan_name . "<br />" . $paymentBasket->item_number . " - <span class='text-info'> Remboursement ref : " . $last_payment->id ."</span>" );
					$convextname = ( $plan_name . "<br /> <span class='text-info'> Remboursement ref : " . $last_payment->id ."</span>");
					//to allow affiliates to sort items according to CB user id
					$type = $paymentBasket->user_id;
				
					$conversion_data_f = array(
					"name" => $convname,
					"component" => "com_comprofiler",
					"extended_name" => $convextname,
					"type" => $type,
					"value" => (float)$value,
					"reference_id" => ( $paymentBasket->id . $last_payment->id ),
					"approved" => 1,
					"atid" => $atid
		);
				$atFile						=	$_CB_framework->getCfg( 'absolute_path' ) . '/components/com_affiliatetracker/helpers/helpers.php';

				if ( ! file_exists( $atFile ) ) {
					return;
				}

			/** @noinspection PhpIncludeInspection */
				include_once( $atFile );
				AffiliateHelper::create_conversion($conversion_data_f, $paymentBasket->user_id);
					}
			
			}			

		//end affiliate tracker
			$payment_exists = 0 ;

			//if(!$paymentBasket->payment_gross) $paymentBasket = $paymentBasket->old;

			if($must_update){
				$query = " SELECT id FROM #__invoices_payments WHERE invoice_id = '".$invoice_id."' AND payment_type = 'payment_".$paymentBasket->payment_method . "' ";
				$db->setQuery($query);
				$payment_exists = $db->loadResult();
			}

			$payment_id = $payment_exists;

			$payments[0] = array(
							"id" => $payment_id,
							"payment_details" => $last_payment->txn_id,
							"payment_datetime" => $last_payment->time_paid,
							"payment_amount" => $last_payment->mc_gross,
							"payment_type" => "payment_".$last_payment->payment_method,
							"payment_description" => $last_payment->payment_type . " - Réglement n°: ".$last_payment->id . " - id : " . $last_payment->txn_id . $reversal,
							"payment_id" => $last_payment->id,
							"payment_status" => $payment_status
							);
		
 // print_r($last_payment);
//  		die;
				

		InvoicesHelper::create_invoice($invoice_data, $items, $payments);
		}
		
		//we transfer the information to the accounting software
		if($is_new){
			$invoice_aha_num = InvoicesHelper::getInvoiceNum($real_invoice_num);
			function extract_basket_item($item)
			{
				return $item->renderColumn();
			}

			// check mc_amount3 if pending or completed and last payment mc_gross if refunded
			$amount = $paymentBasket->mc_amount3;
			if($paymentBasket->payment_status == "Partially-Refunded" || $paymentBasket->payment_status == "Refunded") {
			$amount = -$paymentBasket->mc_amount3 / 2;
			}
			$payment_basket_data = array (
				'date' => $paymentBasket->date,
				'user_id' => $paymentBasket->user_id,
				'txn_type' => $paymentBasket->txn_type,
				'txn_id' => $paymentBasket->txn_id,
				'payment_type' => $paymentBasket->payment_type,
				'address_street' => $paymentBasket->address_street,
				'address_city' => $paymentBasket->address_city,
				'address_state' => $paymentBasket->address_state,
				'address_zip' => $paymentBasket->address_zip,
				'address_country' => $paymentBasket->address_country,
				'payer_business_name' => $paymentBasket->payer_business_name,
				'first_name' => $paymentBasket->first_name,
				'last_name' => $paymentBasket->last_name,
				'payer_email' => $paymentBasket->payer_email,
				'contact_phone' => $paymentBasket->contact_phone,
				'vat_number' => $paymentBasket->vat_number,
				'item_name' => $paymentBasket->item_name,
				'item_number' => $paymentBasket->item_number,
				'quantity' => $paymentBasket->quantity,
				'custom' => $paymentBasket->custom,
				'invoice' => $invoice_aha_num,
				'tax' => $paymentBasket->tax,
				'payment_date' => $paymentBasket->payment_date,
				'shipping' => $paymentBasket->shipping,
				'mc_currency' => $paymentBasket->mc_currency,
				'mc_fee' => $paymentBasket->mc_fee,
				'mc_gross' => $paymentBasket->mc_gross,
				'mc_handling' => $paymentBasket->mc_handling,
				'mc_shipping' => $paymentBasket->mc_shipping,
				'payment_fee' => $paymentBasket->payment_fee,
				'payment_gross' => $paymentBasket->payment_gross,
				'mc_amount3' => $amount,
				'basket_items' => $paymentBasket->loadPaymentItems()
			);

			$context_options = array (
				'http' => array (
					'method' => 'POST',
					'header'  => ['Content-type: application/x-www-form-urlencoded',
										 'Authorization: Bearer 0f24cb76d9f1fa294e50d7d34397c894faac5519'],
					'content' => http_build_query($payment_basket_data)
				)
			);

			$context = stream_context_create($context_options);
			$fp = fopen('https://ipaidthat.io/inv/api/activha-webhook/902', 'r', false, $context);
			fpassthru($fp);
			fclose($fp);
		}
	}	
}	